package meerkat.mixer.mixing;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 * Created by Tzlil on 12/17/2015.
 * container for random permutation
 * the permutation is sated in constructor and can't be change
 */
public class RandomPermutation {
      public final int[] permutation;

    /**
     * constructor
     * @param n permutation size
     * @param random
     */
    public RandomPermutation(int n, Random random) {
        this.permutation = generatePermutation(n,random);
    }

    /**
     * generate random permutation ovver [0,n)
     * @param n permutation size
     * @param random
     * @return permutation
     */
    public static int[] generatePermutation(int n, Random random){
        int[] result = new int[n];

        // initialize and permute in one pass using "inside-out" Fisher-Yates
        for (int i = 0; i < n; ++i) {
            int j = random.nextInt(i+1);

            if (j != i) {
                result[i] = result[j];
            }

            result[j] = i;
        }

        return result;
    }
}
